'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setTravisEnvVar = exports.provide = exports.getTravisEnvVars = exports.createTravisYml = exports.getTravisYmlType = exports.getTravisYmlTypePrompt = exports.createTravisHook = exports.getTravisRepoId = exports.authTravis = exports.createTravis = exports.syncTravis = exports.loadTravisConfig = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _fs = require('fs');

var _path = require('path');

var _userHome = require('user-home');

var _userHome2 = _interopRequireDefault(_userHome);

var _travisCi = require('travis-ci');

var _travisCi2 = _interopRequireDefault(_travisCi);

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _catlStep = require('catl-step');

var _catlStep2 = _interopRequireDefault(_catlStep);

var _yml = require('./yml');

var _yml2 = _interopRequireDefault(_yml);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var noEffect = _catlStep.decorators.noEffect;
var patchObject = _catlStep.decorators.patchObject;


var setTimeoutPromise = function setTimeoutPromise(func /*:Function*/, time /*:number*/) {
  return new Promise(function (resolve) {
    setTimeout(_asyncToGenerator(regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return func();

            case 2:
              resolve();

            case 3:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    })), time);
  });
};

var loadTravisConfig = exports.loadTravisConfig = patchObject('loadTravisConfig')(function (_ref2) {
  var endpoint = _ref2.endpoint;
  var travisPath = _ref2.travisPath;
  var readYmlSync = _ref2.readYmlSync;
  var travisConfig = _ref2.travisConfig;
  return {
    travisConfig: _extends({}, travisConfig || {}, {
      token: readYmlSync(travisPath).endpoints[endpoint + '/'].access_token
    })
  };
});

var syncTravis = exports.syncTravis = noEffect('syncTravis')(function () {
  var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(_ref4) {
    var travis = _ref4.travis;

    var _waitSync, res;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _waitSync = function () {
              var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(travisGetUsers) {
                var bindedWaitSync, _ref6, user;

                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        bindedWaitSync = _waitSync.bind(null, travisGetUsers);
                        _context2.prev = 1;
                        _context2.next = 4;
                        return travisGetUsers();

                      case 4:
                        _ref6 = _context2.sent;
                        user = _ref6.user;

                        if (!user.is_syncing) {
                          _context2.next = 10;
                          break;
                        }

                        _context2.next = 9;
                        return setTimeoutPromise(bindedWaitSync, 300);

                      case 9:
                        return _context2.abrupt('return', _context2.sent);

                      case 10:
                        return _context2.abrupt('return', 'synced');

                      case 13:
                        _context2.prev = 13;
                        _context2.t0 = _context2['catch'](1);
                        _context2.next = 17;
                        return setTimeoutPromise(bindedWaitSync, 1000);

                      case 17:
                        return _context2.abrupt('return', _context2.sent);

                      case 18:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, undefined, [[1, 13]]);
              }));

              return function _waitSync(_x2) {
                return _ref5.apply(this, arguments);
              };
            }();

            _context3.next = 3;
            return travis.syncPost();

          case 3:
            _context3.next = 5;
            return _waitSync(travis.getUsers.bind(travis));

          case 5:
            res = _context3.sent;

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function (_x) {
    return _ref3.apply(this, arguments);
  };
}());

var createTravis = exports.createTravis = patchObject('createTravis')(function (_ref7) {
  var endpoint = _ref7.endpoint;
  var travis = _ref7.travis;
  var travisConfig = _ref7.travisConfig;

  travis = travis || new _travisCi2.default({
    version: '2.0.0',
    headers: {
      'user-agent': 'Oghliner'
    }
  });

  travis.agent._endpoint = endpoint;

  return {
    travis: {
      getRepos: function getRepos(ownerName, repoName) {
        return (0, _es6Promisify2.default)(travis.repos(ownerName, repoName).get, travis);
      },
      putHooks: function putHooks(travisRepoId) {
        return (0, _es6Promisify2.default)(travis.hooks(travisRepoId).put, travis);
      },
      setAccessToken: function setAccessToken(token) {
        console.log(token);
        travis.agent.setAccessToken(token);
      },
      authenticate: function authenticate() {
        return (0, _es6Promisify2.default)(travis.authenticate, travis).apply(undefined, arguments);
      },
      getUsers: function getUsers() {
        return (0, _es6Promisify2.default)(travis.users.get, travis.users).apply(undefined, arguments);
      },
      syncPost: function syncPost() {
        return (0, _es6Promisify2.default)(travis.users.sync.post, travis.users.sync).apply(undefined, arguments);
      },
      agentRequest: function agentRequest() {
        return (0, _es6Promisify2.default)(travis.agent.request, travis.agent).apply(undefined, arguments);
      }
    }
  };
});

var authTravis = exports.authTravis = noEffect('authTravis')(function () {
  var _ref8 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(_ref9) {
    var travis = _ref9.travis;
    var github = _ref9.github;
    var travisConfig = _ref9.travisConfig;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!(travisConfig && travisConfig.token)) {
              _context4.next = 3;
              break;
            }

            travis.setAccessToken(travisConfig.token);
            return _context4.abrupt('return');

          case 3:
            if (travis.token) {
              _context4.next = 7;
              break;
            }

            _context4.next = 6;
            return travis.authenticate({ github_token: github.token });

          case 6:
            travis.token = _context4.sent;

          case 7:

            travis.setAccessToken(travis.token);

          case 8:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function (_x3) {
    return _ref8.apply(this, arguments);
  };
}());

var getTravisRepoId = exports.getTravisRepoId = patchObject('getTravisRepoId')(function () {
  var _ref10 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(_ref11) {
    var travis = _ref11.travis;
    var _ref11$repository = _ref11.repository;
    var ownerName = _ref11$repository.ownerName;
    var projectName = _ref11$repository.projectName;

    var _ref12, travisRepoId;

    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return travis.getRepos(ownerName, projectName)();

          case 2:
            _ref12 = _context5.sent;
            travisRepoId = _ref12.repo.id;
            return _context5.abrupt('return', { travisRepoId: travisRepoId });

          case 5:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function (_x4) {
    return _ref10.apply(this, arguments);
  };
}());

var createTravisHook = exports.createTravisHook = noEffect('createTravisHook')(function () {
  var _ref13 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6(_ref14) {
    var travis = _ref14.travis;
    var travisRepoId = _ref14.travisRepoId;

    var _ref15, result;

    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return travis.putHooks(travisRepoId)({
              hook: {
                active: true
              }
            });

          case 2:
            _ref15 = _context6.sent;
            result = _ref15.result;

            if (result) {
              _context6.next = 6;
              break;
            }

            throw Error();

          case 6:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, undefined);
  }));

  return function (_x5) {
    return _ref13.apply(this, arguments);
  };
}());

var getTravisYmlTypePrompt = exports.getTravisYmlTypePrompt = function getTravisYmlTypePrompt(prompt /*:Function*/) {
  return prompt({
    type: 'list',
    name: 'yml',
    message: 'What kind of `.travis.yml` do you want?',
    choices: ['Single Node.js version.', 'Multiple Node.js versions.', 'Create no `.travis.yml`']
  });
};

var getTravisYmlType = exports.getTravisYmlType = patchObject('getTravisYmlType')(_asyncToGenerator(regeneratorRuntime.mark(function _callee7() {
  return regeneratorRuntime.wrap(function _callee7$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          return _context7.abrupt('return', {});

        case 1:
        case 'end':
          return _context7.stop();
      }
    }
  }, _callee7, undefined);
})));

var createTravisYml = exports.createTravisYml = noEffect('createTravisYml')(function () {
  var _ref17 = _asyncToGenerator(regeneratorRuntime.mark(function _callee8(_ref18) {
    var travisYmlType = _ref18.travisYmlType;
    var writeYmlSync = _ref18.writeYmlSync;
    var travisyml, travisyml_multi, travisFinal;
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            if (!(travisYmlType === 'NO_YML')) {
              _context8.next = 2;
              break;
            }

            return _context8.abrupt('return');

          case 2:
            travisyml = {
              sudo: false,
              language: 'node_js',
              cache: {
                directories: ['node_modules']
              },
              notifications: {
                email: false
              },
              node_js: ['4.4.5'],

              before_install: ['npm i -g npm@^2.0.0'],
              before_script: ['npm prune'],
              after_success: ['npm run catl'],
              branches: {
                // ignore git tags created by catl, like "v1.2.3"
                except: [/^v\d+\.\d+\.\d+$/.toString()]
              }
            };
            travisyml_multi = _extends({}, travisyml, {
              node_js: ['4', 'iojs-v3', 'iojs-v2', 'iojs-v1', '0.12', '0.10'],
              before_script: ['npm prune'],
              after_success: ['curl -Lo travis_after_all.py https://git.io/travis_after_all', 'python travis_after_all.py', 'export $(cat .to_export_back) &> /dev/null', 'npm run catl']
            });
            travisFinal = travisYmlType === 'MULTY_NODE_YML' ? travisyml_multi : travisyml;


            writeYmlSync('.travis.yml', travisFinal);

          case 6:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function (_x6) {
    return _ref17.apply(this, arguments);
  };
}());

var getTravisEnvVars = exports.getTravisEnvVars = patchObject('getTravisEnvVars')(function () {
  var _ref19 = _asyncToGenerator(regeneratorRuntime.mark(function _callee9(_ref20) {
    var agentRequest = _ref20.travis.agentRequest;
    var travisRepoId = _ref20.travisRepoId;
    return regeneratorRuntime.wrap(function _callee9$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            console.log(travisRepoId);
            _context9.next = 3;
            return agentRequest('GET', '/settings/env_vars?repository_id=' + travisRepoId);

          case 3:
            _context9.t0 = _context9.sent;
            return _context9.abrupt('return', {
              travisEnvVars: _context9.t0
            });

          case 5:
          case 'end':
            return _context9.stop();
        }
      }
    }, _callee9, undefined);
  }));

  return function (_x7) {
    return _ref19.apply(this, arguments);
  };
}());

var provide = exports.provide = (0, _catlStep2.default)('provide')([_yml2.default, patchObject('provideTravisPath')(function () {
  return {
    travisPath: (0, _path.join)(_userHome2.default, '.travis/config.yml')
  };
})]);

var getEnvId = function getEnvId(name /*:string*/) {
  return patchObject('getEnvId__' + name)(function (_ref21) {
    var travisEnvVars = _ref21.travisEnvVars;
    var envids = _ref21.envids;

    var envid = _.result(_.find(travisEnvVars, 'name', name), 'id');
    return {
      envids: _extends({}, envids || {}, _defineProperty({}, name, envid ? '/' + envid : ''))
    };
  });
};

var setTravisEnvVar = exports.setTravisEnvVar = function setTravisEnvVar(name /*:string*/, getValue /*:Function*/) {
  return noEffect('setTravisEnvVar__' + name)(function () {
    var _ref22 = _asyncToGenerator(regeneratorRuntime.mark(function _callee10(state) {
      var agentRequest, travisRepoId, envids, value, envid;
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              agentRequest = state.travis.agentRequest;
              travisRepoId = state.travisRepoId;
              envids = state.envids;
              value = getValue(state);

              if (value) {
                _context10.next = 6;
                break;
              }

              throw Error(name + ' is undefined');

            case 6:
              envid = envids[name];
              _context10.next = 9;
              return agentRequest(envid ? 'PATCH' : 'POST', '/settings/env_vars' + envid + '?repository_id=' + travisRepoId, {
                env_var: {
                  name: name,
                  value: value,
                  public: false
                }
              });

            case 9:
            case 'end':
              return _context10.stop();
          }
        }
      }, _callee10, undefined);
    }));

    return function (_x8) {
      return _ref22.apply(this, arguments);
    };
  }());
};

var setEnvVar = function setEnvVar(name /*:string*/, getValue /*:Function*/) {
  return (0, _catlStep2.default)('SET_' + name + '_ENV_VAR')([getEnvId(name), setTravisEnvVar(name, getValue)]);
};

exports.default = (0, _catlStep2.default)('getTravis')([provide, loadTravisConfig, createTravis, authTravis, syncTravis, (0, _catlStep2.default)('setUpTravis')([getTravisRepoId, getTravisEnvVars, createTravisHook, setEnvVar('GH_TOKEN', function (_ref23) {
  var token = _ref23.github.token;
  return token;
}), setEnvVar('NPM_TOKEN', function (_ref24) {
  var token = _ref24.npm.token;
  return token;
}), createTravisYml])]);